<?php

declare(strict_types=1);

namespace ConnectPay\Payment\Gateway\Request;

use ConnectPay\Payment\Gateway\Config\Config;
use ConnectPay\Payment\Gateway\SubjectReader;
use Magento\Framework\Exception\NoSuchEntityException;

class MerchantDataBuilder extends AbstractDataBuilder
{
    /**
     * @var Config
     */
    private $config;

    /**
     * @param Config $config
     * @param SubjectReader $subjectReader
     */
    public function __construct(
        Config        $config,
        SubjectReader $subjectReader
    )
    {
        $this->config = $config;
        parent::__construct($subjectReader);
    }

    /**
     * @param array $buildSubject
     * @return array[]
     * @throws NoSuchEntityException
     */
    public function build(array $buildSubject): array
    {
        return [
            Config::KEY_MERCHANT => [
                Config::KEY_BRAND_ID => $this->config->getBrandId(),
                Config::KEY_WIDGET_LANGUAGE => $this->config->getWidgetLanguage(),
                Config::KEY_REDIRECT_URL => $this->config->getRedirectUrl(),
                Config::KEY_NOTIFICATION_URL => $this->config->getNotificationUrl(),
            ]
        ];
    }
}
