define(
    [
        'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/model/full-screen-loader',
        'mage/url',
    ],
    function ($, Component, fullScreenLoader, url) {
        'use strict';
        return Component.extend({
            defaults: {
                template: 'ConnectPay_Payment/connectpay'
            },
            redirectAfterPlaceOrder: false,
            redirectUrl: window.checkoutConfig.payment.connectpay.connectpayRedirectUrl,
            icon: window.checkoutConfig.payment.connectpay.connectpayIcon,
            providers: window.checkoutConfig.payment.connectpay.connectpaySelectedProviders,
            termsPrivacy: window.checkoutConfig.payment.connectpay.connectpayTermsPrivacy,

            /**
             * After place order callback
             */
            afterPlaceOrder: function () {
                fullScreenLoader.startLoader();
                window.location.replace(url.build(this.getRedirectUrl()));
            },

            /**
             * Return redirect URL
             *
             * @returns {String}
             * @private
             */
            getRedirectUrl: function () {
                return this.redirectUrl;
            },

            getIcon: function () {
                return this.icon;
            },

            getProviders: function () {
                return this.providers;
            },

            getTermsPrivacy: function () {
                return this.termsPrivacy;
            },

            /**
             * Get data
             * @returns {Object}
             */
            getData: function () {
                let selectedProvider = $('input[name="provider"]:checked').val();
                return {
                    'method': this.getCode(),
                    'additional_data': {
                        'connectpay_payment_provider': selectedProvider
                    }
                };
            },
        });
    },
);
